/* This file is part of Eclat.
   Copyright (C) 2012, 2013 Sergey Poznyakoff.
 
   Eclat is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Eclat is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Eclat.  If not, see <http://www.gnu.org/licenses/>. */

#include <config.h>
#include "libeclat.h"
#include "grecs.h"

static void
ec2_param_free(void *ptr)
{
	struct ec2_param *p = ptr;
	free(p->name);
	free(p->value);
	free(p);
}

struct ec2_query *
eclat_query_create(int flags, const char *endpoint, const char *uri)
{
	struct ec2_query *q = grecs_zalloc(sizeof(*q));
	q->flags = flags;
	q->params = grecs_symtab_create(sizeof(struct ec2_param),
					NULL,
					NULL,
					NULL,
					NULL,
					ec2_param_free);
	eclat_query_add_param(q, "Version", EC2_API_VERSION);
	q->endpoint = grecs_strdup(endpoint);
	q->uri = grecs_strdup(uri);
	q->ttl = 5;
	return q;
}
